
/* global Curve, Chart, Graph, THREE */

// 
// agelis dimitrios 2018 all rights reserved


"use strict";

var evn = 0;///user events
function bodyload() {
}

function click() {
    alert("click");
}
function clickdown(event) {
    alert(event.target.id);
}

function clickhelp() {
    hideelement(getelement("help"));
}
setbackcolor(getelement("body"), "black");
var gf = new GF();
var sm = gf.getmanager();

var ttcolor = "pink";

var appw = sm.width;
var apph = sm.height;
var logw = appw;
var logh = apph;
sm.adddebug();/// here because form


sm.dwin.drawoutline = true;
sm.dwin.x = 800;

sm.setbackcolor(0, 0, 0);
sm.drawbackground = false;//true; /// dont draw background if have a 2d or 3d app


var scene0 = sm.createscene();      ///  0


scene0.userevent = function (e, type) {
    evn++;
    if (type === "MU") {
    }
    //info.title=concat(e.target,evn);
}

////  app 
var appname = "Κίνηση σε κεκλιμένο επίπεδο"

var helptext = "Μπορείς να μεταβάλεις τις διάφορες παραμέτρους για να δεις την κίνηση ενός σώματος πάνω σε κεκλιμένο επίπεδο. # μ: Συντελεστής Τριβής ολισθήσεως. # μσ: Συντελεστής στατικής Τριβής. # Τ: Τριβή, Τσ max: μέγιστη τιμή της Στατικής Τριβής. # Vo: Αρχική ταχύτητα."
var gui = scene0.addform(0, "", 0, 0, appw, apph);

gui.drawbackground = false;
gui.pickable = false;
/// -------------------------resources


//var imright = sm.createimage("images/1.png");



///------------------  appplication var ---------------------

var x0 = 240;
var y0 = 320;



////-------------polar supprort-------------
var polmatrix = [];
var polarx, polary;
var tra = new Transform();
function polars(x, y, r, th) {
    getpolar(x, y, r, th, polmatrix)
    polarx = polmatrix[0];
    polary = polmatrix[1];
}
///////////////////////////////-------------------
var rx = 40;
var ry = 40; ///of rect 
var xx, yy, xx0;// of rect ///
var x1, y1;
var xxpix;
var fx, fy, mi, mis, v0, mass, ax, vx, vx0, sx, gi, we;
var ni = 0;
var tol, tmax, tr, t;

var th, wx, wy;

var form0 = gui.addform("form0", "", 0, 48, appw, apph - 48);
form0.backcolor = "white";
var pa2= form0.addform(0,"",0,apph-48-30,1080-16,30);
pa2.backcolor="white";

var panel1 = form0.addform(0, "", 1080 - 16, 0, 200 + 16, 720-48);
panel1.backcolor="white";
panel1.backout(true,true);
panel1.corner=2;


var dele=140;
var lx=pa2.addlabel(0,"x",10,0,dele,30);
var lv=lx.addlabel(0,"v",dele+10,0,dele,30);
var lwx=lv.addlabel(0,"wx=",dele+10,0,dele,30);
var lwy=lwx.addlabel(0,"wy=",dele+10,0,dele,30);
var ln=lwy.addlabel(0,"N=",dele+10,0,dele,30);
var lts=ln.addlabel(0,"N=",dele+10,0,dele,30);
var lt=lts.addlabel(0,"N=",dele+10,0,dele,30);

var ms1 = form0.addmultistate(0, "", 1100, 600, 48, 48);
ms1.addstate(0, "", sm.createimage("images/clock1.png"))
ms1.addstate(1, "", sm.createimage("images/clock2.png"))
ms1.onmouseup = function () {
    form0.stopped = (ms1.state === 1);
}
var ms2 = form0.addmultistate(0, "", 1150, 600, 48, 48);
ms2.addstate(0, "", sm.createimage("images/clock3.png"))

ms2.onmouseup = function () {
    form0.t = 0;
    xx0 = 0;
    xx = 0;
    vx = sb[4].value;
}
var sb = [];
var scrolltitles = ["Fx", "Fy", "μ", "μσ", "Vo", "m", "θ"];
var scrollunits = ["N", "", "", "", "m/s", "Kg", "⁰"];
var smin = [-5, -5, 0, 0, -10, 1, -75];
var smax = [20, 10, 2, 2, 10, 2, 75];
var svalue = [0, 0, 0.2, 0.4, 0, 1, 0];
var klim;
var klimv = 10;
var klimf = 20;
var lbl = [];
var lbltext = ["Toλ=", "Τσmax=", "α=", "υ=", "x=", "t=", "Τ="]
var lblval = [0, 1, 2, 3, 4, 5, 6]
///// create now 
create();

sm.onvaluechange = function (ob) {
    form0.t = 0;


    if (ob.id === 2) {
        /// m olis
        if (sb[3].value < sb[2].value) {
            sb[3].value = sb[2].value;
            sb[3].setvalues(sb[3].min, sb[3].max, sb[3].value);

        }
    }
    if (ob.id === 3) {
        /// m olis
        if (sb[3].value < sb[2].value) {
            sb[2].value = sb[3].value;
            sb[2].setvalues(sb[2].min, sb[2].max, sb[2].value);

        }
    }
    if (ob.id === 4) {
        vx0 = ob.value;
        vx = vx0;
    } else
        vx0 = vx;
    xx0 = xx;

    // lbltext[0].title=ob.value;

}


function create() {
    klim = 10;
    t = 0;
    mass = 1;
    gi = 10;
    xx = 0;
    yy = y0;
    xx0 = xx;
    vx = 0;
    vx0 = 0;
    var i;
    for (i = 0; i < scrolltitles.length; i++) {
        sb[i] = panel1.addscrollbar(i, "", 8, 40 + i * 70, 200, 48);
        sb[i].setvaluepos(64, -24);
        sb[i].setvaluedescr(scrolltitles[i], scrollunits[i], 1 * (i !== 6));
        sb[i].setvalues(smin[i], smax[i], svalue[i]);
        sb[i].astep = 0.1;
    }


    for (i = 0; i < lbltext.length; i++) {
        lbl[i] = form0.addlabel(0, lbltext[i], i * 150, 50, 70, 32);
        lbl[i].textcentered = false;
        lbl[i].backout(false);
        lbl[i].visible = false;
    }
    lbl[5].visible = !false;
    lbl[2].visible = false;
    lbl[3].visible = false;
    ///// test step(n astep)
    lbl[5].x = ms1.x + 18;
    lbl[5].y = ms1.y - 32;
    lbl[1].move(460, 10);
    lbl[6].move(lbl[1].x + 200, lbl[1].y);
}
function init() {
    vx0 = sb[4].value;

}



function labels() {
    lbl[0].title = lbltext[0] + todecimal(tol, 2);
    lbl[1].title = lbltext[1] + todecimal(tmax, 2) + "N";
    lbl[2].title = lbltext[2] + todecimal(ax, 2);
    lbl[3].title = lbltext[3] + todecimal(vx, 2);
    lbl[4].title = lbltext[4] + todecimal(xx, 2) + "m";
    lbl[4].x = x1 + rx;
    lbl[4].y = y1 + ry + 12;
    lbl[5].title = lbltext[5] + todecimal(t, 2) + "s";
    lbl[6].title = lbltext[6] + todecimal(tr, 2) + "N";
    
    lx.title="x="+todecimal(xx, 2) + "m";
    lv.title="υ="+todecimal(vx, 2) + "m/s";
     lwx.title="wx="+todecimal(wx, 2) + "N";
     lwy.title="wy="+todecimal(wy, 2) + "N";
     ln.title="N="+todecimal(ni, 2) + "N";
     lts.title="Τσ max="+todecimal(tmax, 2) + "N";
     lt.title="Τ="+todecimal(tr, 2) + "N";
}



function update() {
    var mat = [];
    tra.reset();
    tra.rotate(th);
    th = torad(sb[6].value);
    mass = sb[5].value;
    t = form0.t
    fx = sb[0].value;

    fy = sb[1].value;

    we = mass * gi;
    wx = we * Math.sin(th)
    wy = we * Math.cos(th)

    ni = wy - fy;

    tmax = sb[3].value * ni;
    tol = sb[2].value * ni;/// *(abs(vx)>tolv);
    tr = 0;
    if (vx === 0) {
        if (abs(fx + wx) <= tmax) {

            tr = -abs(fx + wx) * sign(fx + wx);
        }
        if (abs(fx + wx) > tmax)
            tr = -tol * sign(fx + wx)
    } else
        tr = -tol * sign(vx)
    var sfx = fx + wx + tr;
    ax = sfx / mass;

    labels();
    
    /// compute pos


    var vt = vx;
    var dt = form0.dt
    vx = vx + ax * dt;
    if (vt * vx < 0) vx = 0;
    xx = xx + (vx + vt) / 2 * dt;
    xxpix = x0 + klim * xx * cos(th);
    x1 = xxpix;
    y1 = yy + klim * xx * sin(th);
    
  ////////////////////////////////////////////////////
  //
    
    /// ground
    ///axis x
    linewidth(form0.ctx, 1);
    form0.dash([1, 1])
    styles(form0.ctx, "black")
    form0.drawpolarvector(x0, y0, 678, th);
     form0.drawpolar(x0, y0, 200, th + Math.PI);
     form0.drawpolar(x0, y0,  280, th + Math.PI / 2);
    form0.drawpolarvector(x0, y0, 300 , th - Math.PI / 2);
    
    form0.drawpolar(x1, y1+we*klimf,wy*klimf,  th - Math.PI / 2);
     form0.drawpolar(x1, y1+we*klimf,wx*klimf,  th+ Math.PI );
    
    form0.dash([]);
    linewidth(form0.ctx, 4);
    styles(form0.ctx, "black")
    //form0.drawline(x0 - 640, y0 + ry + 3, x0 + 640, y0 + ry + 3)
    //styles(form0.ctx, "blue")
    /// draw rect ;
    linewidth(form0.ctx, 1.5);
    
    
    styles(form0.ctx, "lightgrey", "lightgrey");
    /// draw cube
    mat = tra.transformPolygon([-rx, -ry, rx, -ry, rx, ry, -rx, ry, -rx, -ry])
    var i;
    for (i = 0; i < 50; i++) {
        mat[2 * i] += x1;
        mat[2 * i + 1] += y1;
    }
    form0.drawpolygon(mat, 2);
    mat = tra.transformPolygon([0, ry]);
  linewidth(form0.ctx, 3);
    styles(form0.ctx, "black")
    form0.drawpolar(x0+mat[0], y0+mat[1],1200,th);
     form0.drawpolar(x0+mat[0], y0+mat[1],1200,0+Math.PI+th);
  linewidth(form0.ctx, 1.5);
    ///form0.drawrect(x1 - rx, y1 - ry, 2 * rx, 2 * ry, 2);
    ///// draw vectors;
    styles(form0.ctx, rgb(153, 153, 102))
    form0.drawarrow(x1, y1, we * klimf, Math.PI / 2, 16, 3, 2);
    ///wx wy
    form0.drawarrow(x1, y1, wx * klimf, th, 16, 3, 2);
    form0.drawarrow(x1, y1, wy * klimf, th + Math.PI / 2, 16, 3, 2);
    styles(form0.ctx, rgb(87, 154, 255))
    form0.drawarrow(x1, y1, ni * klimf, th - Math.PI / 2, 16, 3, 2);
    styles(form0.ctx, rgb(0, 200, 0))
    form0.drawarrow(x1, y1, fx * klimf, th, 16, 3, 2);
    form0.drawarrow(x1, y1, fy * klimf, th - Math.PI / 2, 16, 3, 2);
    styles(form0.ctx, "red");
    form0.drawarrow(x1, y1, tr * klimf, th, 16, 3, 2);
    styles(form0.ctx, "blue");

    mat = tra.transformPolygon([+rx, -2 * ry])
    form0.drawarrow(x1 + mat[0], y1 + mat[1], vx * klimv, th, 8, 1.5, 2);



    form0.drawtext("w", x1, y1 + we * klimf + 22, 24);
    if (ni) {


        mat = tra.transformPolygon([26, -ni * klimf])

        form0.drawtext("N", x1 + mat[0], y1 + mat[1], 24);
        //form0.drawtext("N", x1 - 22, y1 - abs(ni) * klimf, 24);
    }
    if (fy) {

        mat = tra.transformPolygon([-24, -fy * klimf])
        form0.drawtext("Fy", x1 + mat[0], y1 + mat[1], 24);
    }
    if (fx) {
        mat = tra.transformPolygon([fx * klimf, -24])
        form0.drawtext("Fx", x1 + mat[0], y1 + mat[1], 24);
        //form0.drawtext("Fx", x1 + fx * klimf, y1 - 22, 24);

    }
    if (tr) {

        mat = tra.transformPolygon([tr * klimf, -24])
        form0.drawtext("T", x1 + mat[0], y1 + mat[1], 24);
    }
    if (vx) {
        mat = tra.transformPolygon([rx + vx * klimv, -22 - 2 * ry])
        //form0.drawtext("υ", x1 + rx + vx * klimv, y1 - 22 - 2 * ry);
        form0.drawtext("υ", x1 + mat[0], y1 + mat[1]);

    }
}




form0.userdraw = function (ctx) {
    update();

    styles(form0.ctx, "black")
    var ob = form0.getmousepos();
    //form0.drawtext(toround(ob.x) + "," + toround(ob.y), 0, 44, 16, true);
    ob = form0.getover();
    if (ob) {
        //form0.drawtext(toround(ob.x) + "," + toround(ob.y), 0, 44, 40, true);   


    }

}

//-------------------------------------  app var






//////////////////////      etc /////////////////////

var label2 = gui.addlabel(0, appname, 0, 0, appw, 48);
label2.backcolor = "orange";
label2.backcolor = "lightgrey";
label2.textcentered = false;//

var btnabout = label2.addbutton(0, "", appw - 48, 0, 48, 48, sm.getimageres("about"));
btnabout.drawbackground = false;
btnabout.drawoutline = false;

var btnhelp = label2.addbutton(0, "", appw - 100, 0, 48, 48, sm.getimageres("help"));
btnhelp.drawbackground = false;
btnhelp.drawoutline = false;
//var sceneabout = sm.adddialog(512, 360, sm.createimage("images/about.png"), 0);/// scene 1

btnabout.onclick = function () {
    window.open('index_DS_II.html');
    //formabout.visible = !false;
}
btnhelp.onclick = function () {
    formhelp.visible = !formhelp.visible;//false;

}



var formhelp = gui.addform(0, "", 0, 0, 610, 170);
formhelp.backcolor = "lightgreen"
formhelp.userdraw = function (ctx) {
    //function wraptext(ctx, text, x, y, maxWidth, lineHeight) {
    wraptext(formhelp.ctx, helptext, formhelp.xg + 8, formhelp.yg + 28, formhelp.width - 55, 24)
}

formhelp.visible = false;
formhelp.center();

var bc1 = formhelp.addbutton(0, "", formhelp.width - 56, 0, 48, 48, sm.getimageres("close"));
bc1.drawoutline = false;

bc1.drawoutline = false;
bc1.onclick = function () {
    formhelp.visible = false;
}

bc1.drawbackground = false;
bc1.drawoutline = false;



init();

gf.start();





